import random
from statistics import mean, stdev

import matplotlib.pyplot as plt


FEMALE_WORDS = ["female", "woman", "girl", "sister", "she", "her", "hers", "daughter"]
MALE_WORDS = ["male", "man", "boy", "brother", "he", "him", "his", "son"]


class WordEmbeddings:
    def __init__(self, filename):
        # load embeddings from file
        self.embeddings = {}
        f = open(filename, "r")
        first_line = f.readline()
        self.dimensions = int(first_line.split()[1])
        for line in f:
            split_line = line.split(" ")
            assert len(split_line) == self.dimensions + 1
            self.embeddings[split_line[0]] = []
            for num in split_line[1:]:
                self.embeddings[split_line[0]].append(float(num))
        f.close()        

    def similarity(self, word1, word2):
        """
        ACTIVITY 1: write the similarity method
        """

    
    def score(self, profession):
        """
        ACTIVITY 2: write the score method
        """


    def compute_many_similarities(self, word, other_words):
        """
        Computes the cosine similarity between word and all of the words in other_words and returns
        them in a list

        Args:
            word (str): the word
            other_words (List[str]): a list of other words

        Returns:
            List[float]: the cosine similarities (in the same order as other_words)
        """
        similarities = []
        for other_word in other_words:
            similarities.append(self.similarity(word, other_word))
        return similarities



def create_plot(group_members):
    # load professions data from file
    professions = {}
    f = open("professions.txt", "r")
    for line in f:
        split_line = line.split()
        professions[split_line[0]] = float(split_line[1])
    f.close()

    # prints so that you can see what it looks like!
    print(professions)

    emb = WordEmbeddings("embeddings_filtered.txt")

    # x and y values for plotting
    x = []
    y = []
    for profession in professions:
        x.append(professions[profession])
        y.append(emb.score(profession))

    # makes the scatter plot a random color for fun
    # if you want, you can keep running the code until you like the color 
    # - or use your own RGB values!
    # note that instead of normal RGB values, matplotlib uses intensities from 0-1
    color = (random.random(), random.random(), random.random())
    plt.scatter(x, y, c=[color])
    plt.xlabel("Proportion of workers in occupation who are women")
    plt.ylabel("Strength of association of\noccupation word vector with female gender")
    plt.title(group_members + "'s plot")
    plt.savefig("bias.png")

"""
ACTIVITY 3: call the create_plot function
"""



"""
ACTIVITY 4: BERT

Which major did you experiment with? 
"""

"""
ACTIVITY 5: Reflection.
WRITE AT LEAST ONE FULL SENTENCE FOR EACH QUESTION!

One word that might be used to describe these word representations is “biased”.
Can you think of automated systems in which it would be harmful to society to use these 
representations of words?
YOUR ANSWER: 


Can you think of any situations in which the fact that these word representations are biased might
be an asset?
YOUR ANSWER: 


If you use tools like ChatGPT, will this change how you use those tools? If you don't, does this 
change your likelihood to use the tools, or the tasks that you might consider using them for?
YOUR ANSWER:
"""